---
title: Pagination
slug: Web/CSS/Layout_cookbook/Pagination
tags:
  - CSS
  - CSS Cookbook
  - Guide
  - css layout
  - flexbox
  - pagination
---
<p>{{CSSRef}}</p>

<p class="summary">This cookbook pattern demonstrates the navigation pattern used to display pagination, where the user can move between pages of content such as search results.</p>

<p><img alt="Links to sets of pages in a paged listing" src="https://mdn.mozillademos.org/files/16279/pagination.png" style="height: 192px; width: 950px;"></p>

<h2 id="Requirements">Requirements</h2>

<p>The pagination pattern typically displays items in a row. To ensure that the pagination is understandable by people using a screenreader, we mark the items up as a list inside a {{htmlelement("nav")}} element, and then use CSS to display the layout visually as a row.</p>

<p>Typically, the pagination component will be centered horizontally underneath the content.</p>

<h2 id="Recipe">Recipe</h2>

<p>{{EmbedGHLiveSample("css-examples/css-cookbook/pagination.html", '100%', 720)}}</p>

<div class="note">
<p><a href="https://github.com/mdn/css-examples/blob/master/css-cookbook/pagination--download.html">Download this example</a></p>
</div>

<h2 id="Choices_made">Choices made</h2>

<p>This pattern is laid out using <a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout">flexbox</a> — one flex container nested inside another. The {{htmlelement("nav")}} element is designated a flex container in order that we can center the list inside using the {{cssxref("justify-content")}} property.</p>

<p>The list itself also becomes a flex container to lay the items out as a row. To space the items out we will use a {{cssxref("margin")}} on the flex items.</p>

<h2 id="Alternative_methods">Alternative methods</h2>

<p>Once the {{cssxref("column-gap")}} property has implementation in browsers this could be used instead of margins to space out the items.</p>

<pre class="brush: css notranslate">.pagination {
  list-style: none;
  margin: 0;
  padding: 0;
  display: flex;
  column-gap: 2px;
}
</pre>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>We want to ensure that a person using a screenreader understands what this navigation does, and where they will go when clicking a link. To help with this we have added <code>aria-label="pagination"</code> on the <code>&lt;nav&gt;</code> element. </p>

<p>We have also added some additional content that would be read by a screenreader but is hidden visually, and set the <code>aria-hidden</code> attribute on the paging arrows.</p>

<p>The "See Also" section at the end of this document has links to related accessibility topics.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>The various layout methods have different browser support. See the charts below for details on basic support for the properties used.</p>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p><em>Include the compat data for key properties you used, as in the example below which includes align-items.</em></p>

<h4 id="justify-content">justify-content</h4>

<p>{{Compat("css.properties.justify-content")}}</p>

<h4 id="column-gap_in_Flex_layout">column-gap in Flex layout</h4>

<p>{{Compat("css.properties.column-gap.flex_context")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{Cssxref("justify-content")}}, {{Cssxref("column-gap")}}</li>
 <li><a href="https://www.scottohara.me/blog/2018/05/05/hidden-vs-none.html">Know your ARIA: 'Hidden' vs 'None'</a></li>
 <li><a href="https://webaim.org/techniques/css/invisiblecontent/#techniques">Invisible content just for screen reader users</a></li>
 <li><a href="https://medium.com/@matuzo/writing-css-with-accessibility-in-mind-8514a0007939">Writing CSS With Accessibility in mind</a></li>
 <li><a href="http://a11y-style-guide.com/style-guide/section-navigation.html#kssref-navigation-pagination">a11y Style Guide: Pagination</a></li>
</ul>
